<!DOCTYPE html>
<html>

<head>
  <title> Task 26.20 ... Order Details </title>
  <meta charset='utf-8'>
  <meta name='viewport' content='width=device-width, initial-scale=1'>
  <link rel="stylesheet" href="https://maxcdn.bootstrapcdn.com/bootstrap/4.5.2/css/bootstrap.min.css">
  <script src="https://cdnjs.cloudflare.com/ajax/libs/jquery/3.6.0/jquery.min.js"></script>
  <script src="https://maxcdn.bootstrapcdn.com/bootstrap/4.5.2/js/bootstrap.min.js"></script>
</head>

<body onload="onPageLoading()">
  <div class="container jumbotron ">
    <div class="col-12 ">
      <div class="text-center mb-5 " > <h1 style="color:goldenrod"> Order Detail</h1> </div>
       
      <label class="col-sm-12 col-form-label">Order Code (mã đơn hàng)</label>
        <div class="col-sm-12">
          <input id="inp-order-code" type="text" class="form-control" placeholder="...">
        </div>
      
      <label class="col-sm-12 ">Cỡ Combo</label>
        <div class="col-sm-12">
          <select id="select-size" class="form-control">
            <option value="not_selected_combo"> Chọn cỡ Combo (Combo size)</option>
            <option value="S"> Nhỏ</option>
            <option value="M"> Vừa</option>
            <option value="L"> Lớn</option>
          </select>
        </div>
      
      <label class="col-sm-12 col-form-label">Đường kính pizza</label>
        <div class="col-sm-12">
          <input id="inp-size-pizza" type="text" class="form-control" placeholder="...">
        </div>

      <label class="col-sm-12 col-form-label">Sườn nướng (miếng)</label>
        <div class="col-sm-12">
          <input id="inp-ribs" type="text" class="form-control" placeholder="...">
        </div>

      <label class="col-sm-12 col-form-label">Đồ uống</label>
        <div class="col-sm-12">
          <select class="form-control" id="select-drink">
            <input id="select-drink" type="text" class="form-control" placeholder="...">
          </select>
        </div>

      <label class="col-sm-12 col-form-label">Số lượng nước uống</label>
        <div class="col-sm-12">
          <input id="inp-drink-number" type="text" class="form-control" placeholder="...">
        </div>

      <label class="col-sm-12 col-form-label">Voucher ID</label>
        <div class="col-sm-12">
          <input id="inp-voucher-id" type="text" class="form-control" placeholder="...">
        </div>
      
      <label class="col-sm-12 col-form-label">Loại pizza</label>
        <div class="col-sm-12">
          <select id="select-pizza" class = "form-control">            
            <option value="not_selected_pizza"> Chọn loại pizza </option>
            <option value = "Seafood" > Hải sản</option>
            <option value = "Hawaii"> Ha wai </option>
            <option value = "Bacon" > Thịt hun khói </option>
          </select>
        </div>      

      <label class="col-sm-12 col-form-label">Salad</label>
        <div class="col-sm-12">
          <input id="inp-salad" type="text" class="form-control" placeholder="...">
        </div>

      <label class="col-sm-12 col-form-label">Thành tiền</label>
        <div class="col-sm-12">
          <input id="inp-amount" type="text" class="form-control" placeholder="...">
        </div>

      <label class="col-sm-12 col-form-label">Giảm giá</label>
        <div class="col-sm-12">
          <input id="inp-discount" type="text" class="form-control" placeholder="...">
        </div>

      <label class="col-sm-12 col-form-label" for="">Họ và tên</label>
        <div class="col-sm-12">
          <input id="inp-full-name" type="text" class="form-control" placeholder="..."> 
        </div>
    
      <label class="col-sm-12 col-form-label">Email</label>
        <div class="col-sm-12">
          <input id="inp-email" type="email" class="form-control" placeholder="..."> 
        </div>

      <label class="col-sm-12 col-form-label">Số điện thoại</label>
        <div class="col-sm-12">
          <input id="inp-phone-number"type="text" class="form-control" placeholder="...">
        </div>
      
      <label class="col-sm-12 col-form-label">Địa chỉ</label>
        <div class="col-sm-12">
          <input id="inp-address" type="text" class="form-control" placeholder="..."> 
        </div>

      <label class="col-sm-12 col-form-label">Lời nhắn</label>
        <div class="col-sm-12 form-group">
          <textarea id="inp-message" class="form-control" placeholder="..."></textarea>
        </div>

      <label class="col-sm-12 col-form-label">Trạng thái đơn hàng</label>
        <div class="col-sm-12">
          <input id="inp-order-status" type="text" class="form-control" placeholder="...">
        </div>

      <label class="col-sm-12 col-form-label">Ngày tạo đơn</label>
        <div class="col-sm-12">
          <input id="inp-order-date" type="text" class="form-control" placeholder="...">
        </div>

      <label class="col-sm-12 col-form-label">Ngày cập nhật</label>
        <div class="col-sm-12">
          <input id="inp-update-date" type="text" class="form-control form-group" placeholder="...">
        </div>
        
      <div class="col-sm-12 form-group"> <!--Buttons-->
        <a id="btn-confirm-click" class="col-sm-2 btn btn-success ">Confirm</a>
        <a id="btn-cancel-click" class="col-sm-2 btn btn-primary " href="file:///C:/Users/hphat/Desktop/J2232/2023-02-10/Task%2025.30/task25.30.pizza365.create.and.getOrder.v4.5.html" >Cancel</a>
      </div>
    </div> 
  </div>
  
</body>

<script>
  "use strict";
  /*** REGION 1 - Global variables - Vùng khai báo biến, hằng số, tham số TOÀN CỤC */
  const gREQUEST_STATUS_OK = 200;
  const gREQUEST_READY_STATUS_FINISH_AND_OK = 4;
  const gREQUEST_CREATE_SUCCESS = 201;
  const gBASE_URL = "http://203.171.20.210:8080/devcamp-pizza365/orders";
  const gBASE_URL_DRINK = "http://203.171.20.210:8080/devcamp-pizza365/drinks";

  /*** REGION 2 - Vùng gán / thực thi sự kiện cho các elements */
  /*** REGION 3 - Event handlers - Vùng khai báo các hàm xử lý sự kiện */
 
  function onPageLoading() {
    //get parameter from query string
    var vOrderParam = getParameter();
    console.log("%cORDER ID: ","color:orange", vOrderParam[0]);
    var vParamOrderCode = vOrderParam[1]
    console.log("%cORDER CODE: ","color:orange", vParamOrderCode);
    
    //validate the query string
    var vValidateResult = validateQueryString(vOrderParam);
    
    //call API to det the order data
    var vXmlHttpGetAllOrders = new XMLHttpRequest();
    callApiOrderData(vXmlHttpGetAllOrders, vParamOrderCode);
    vXmlHttpGetAllOrders.onreadystatechange = function(){
      if (this.readyState == gREQUEST_READY_STATUS_FINISH_AND_OK && this.status == gREQUEST_STATUS_OK){
        var vJsonParsing = JSON.parse(this.responseText);
            console.log("%cRESPONSE-PARSING: ","color:orange", vJsonParsing);
        displayDataWeb(vJsonParsing);
      }
    }
  }

  //get parameter from query string
  function getParameter(paramId, paramCode){
    //locate the parameter from the query string
    var vParamURL = window.location.href
    
    //get the parameter
    var vUrl = new URL(vParamURL);
    var vOrderId = vUrl.searchParams.get("id");
    var vOrderCode = vUrl.searchParams.get("orderCode");
        //console.log("%cORDER ID: ","color:orange", vOrderId);
        //console.log("%cORDER CODE: ","color:orange", vOrderCode);
    paramId = vOrderId;
    paramCode = vOrderCode;
    return [paramId , paramCode];
  }

  //validate the query string
  function validateQueryString(paramData){
    if (paramData[0] == null || paramData[0] == ""){
      alert("Query string is not being located !!!");
      location.href = "file:///C:/Users/hphat/Desktop/J2232/2023-02-11/Task%2026.10/indexListView.html"
    }
    else if (paramData[1] == null || paramData[1] =="")
    {
      alert("Query string is not being located !!!");
      location.href = "file:///C:/Users/hphat/Desktop/J2232/2023-02-11/Task%2026.10/indexListView.html"
    }
  }

  //call API to get the order data
  function callApiOrderData(paramData, paramCode){
    paramData.open("GET", gBASE_URL + "/" + paramCode, true);
    paramData.send();
  }

  //display the obtained data to the web form
  function displayDataWeb(paramData){
    console.log("%cORDER PARAM-CODE: ","color:orange", paramData.orderCode)
    //reach to the html's elements
    var vOrderCodeElement = document.getElementById("inp-order-code");
    var vComboElement = document.getElementById("select-size");
    var vPizzaSizeElement = document.getElementById("inp-size-pizza");
    var vRibsElement = document.getElementById("inp-ribs");
    var vDrinkElement = document.getElementById("select-drink");
    var vDrinkNumberElement = document.getElementById("inp-drink-number");
    var vVoucherIdElement = document.getElementById("inp-voucher-id");
    var vPizzaElement = document.getElementById("select-pizza");
    var vSaladElement = document.getElementById("inp-salad");
    var vAmountElement = document.getElementById("inp-amount");
    var vDiscountElement = document.getElementById("inp-discount");
    var vFullNameElement = document.getElementById("inp-full-name");
    var vEmailElement = document.getElementById("inp-email");
    var vPhoneElement = document.getElementById("inp-phone-number");
    var vAddressElement = document.getElementById("inp-address");
    var vMessageElement = document.getElementById("inp-message");
    var vStatusElement = document.getElementById("inp-order-status");
    var vOrderDateElement = document.getElementById("inp-order-date");
    var vUpdateDateElement = document.getElementById("inp-update-date");
    
    
      vOrderCodeElement.value = paramData.orderCode;
      vComboElement.value = paramData.kichCo;
      vPizzaSizeElement.value = paramData.duongKinh;
      vRibsElement.value = paramData.suon;
      
   //get data of the drink's list
    var vDrinkApi = callApiDrinkList();
        var vDrinkParsed = JSON.parse(vDrinkApi);
            console.log("%cdrink NAME: ", "color:orange", vDrinkParsed);
            console.log("%cdrink ID: ", "color:orange", paramData.idLoaiNuocUong);
        for (var index=0; index < vDrinkParsed.length; index++){
          if (vDrinkParsed[index].maNuocUong === paramData.idLoaiNuocUong){
            vDrinkElement.value = vDrinkParsed[index].tenNuocUong;  
          }
        }
        
    //call API for getting the drink's list
    function callApiDrinkList(){
      
      var vXmlHttp = new XMLHttpRequest();
          vXmlHttp.open("GET", gBASE_URL_DRINK, false);
          vXmlHttp.send();
          
          vXmlHttp.onreadystatechange = function(){
            if (this.readyState == gREQUEST_READY_STATUS_FINISH_AND_OK && this.status == gREQUEST_STATUS_OK){
              console.log("%cdrink list: ", "color:orange", this.responseText);
            }
          }
          return vXmlHttp.responseText;
          var vDrinkParsing = JSON.parse(vXmlHttp.responseText);
              console.log("%cdrink list length: ", "color:orange", vDrinkParsing);
     }
    

      vDrinkNumberElement.value = paramData.soLuongNuoc;
      vVoucherIdElement.value = paramData.idVourcher;
      vSaladElement.value = paramData.salad;
      vPizzaElement.value = paramData.loaiPizza;
      vAmountElement = paramData.thanhTien;
      vDiscountElement.value = paramData.giamGia;
      vFullNameElement.value = paramData.hoTen;
      vEmailElement.value = paramData.email;
      vPhoneElement.value = paramData.soDienThoai;
      vAddressElement.value = paramData.diaChi;
      vMessageElement.value = paramData.loiNhan;
      vStatusElement.value = paramData.trangThai;
      vOrderDateElement.value = paramData.ngayTao;
      vUpdateDateElement.value = paramData.ngayCapNhat;
      
  }

</script>

</html>